%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% tex packages                                                               %%

\RequirePackage{pgf}
\RequirePackage{pgfplots}
\RequirePackage{pgfkeys}
\RequirePackage{xparse}
\RequirePackage[%
  usenames,%
  svgnames,%
  dvipsnames,%
]{xcolor}
\RequirePackage{relsize}

%% END tex packages                                                           %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%





%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% additional tikz/pgf libraries to load                                      %%

\usepgflibrary{plotmarks}
\usepgflibrary{fpu}
\usetikzlibrary{colorbrewer}
\usetikzlibrary{arrows}
\usetikzlibrary{arrows.meta}
\usetikzlibrary{calc}
\usetikzlibrary{patterns}
\usetikzlibrary{decorations.pathmorphing}
\usetikzlibrary{decorations.markings}

\pgfplotsset{compat=newest}

%% END additional tikz/pgf libraries to load                                  %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%





%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% colors                                                                     %%

%% END colors                                                                 %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%





%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% commands                                                                   %%

\makeatletter

% |\tikztikzmechsset| allows keys that belong with tikz-tikzmechs to be easily set.
\newcommand\tikztikzmechsset[1]{\tikzset{/tikzmechs/.cd, #1}}%
% |\tikztikzmechsget| allows keys that belong with tikz-tikzmechs to be easily retrieved.
\newcommand\tikztikzmechsget[1]{\pgfkeysvalueof{/tikzmechs/#1}}%
% |\tikztikzmechsresetstyle| allows resetting a style within tikz-tikzmechs quite easily
\newcommand\tikztikzmechsresetstyle[1]{\tikzset{/tikzmechs/#1/.style={}}}%

%% END commands                                                               %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%





%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% pgf keys                                                                   %%

\pgfkeys{%
  % This namespace is a family of namespaces
  /tikzmechs/.is family,%
  % Fall back to searching inside /tikz/
  /tikzmechs/.belongs to family=/tikz,%
  % Forward anything unknown to the '/tikz' namespace
  /tikzmechs/.unknown/.forward to=/tikz,%
}%

% Set an initially empty style for "remaining keys"
\tikztikzmechsresetstyle{remaining keys}%

\newlength\tikz@tikzmechs@markersize
\tikztikzmechsset{%
  % Default marker size for automatically marked lines
  marker size/.code={%
    \setlength{\tikz@tikzmechs@markersize}{#1}%
  },%
  marker size=0.33ex,%
  % Default number of markers for automatically marked lines
  marker count/.initial=5,%
  % Remaining keys not matching in this namespace
  remaining keys/.style={},%
  % collect unknown keys in style '/tikzmechs/remaining keys':
  .unknown/.code={%
    \let\currname\pgfkeyscurrentname%
    \let\currval\pgfkeyscurrentvalue%
    \ifx#1\pgfkeysnovalue%
      \pgfqkeys{/tikzmechs}{%
        remaining keys/.append style/.expand once={\currname}%
      }%
    \else%
      \pgfqkeys{/tikzmechs}{%
        remaining keys/.append style/.expand twice={\expandafter\currname\expandafter=\currval}%
      }%
    \fi%
  }%
}%

%% END pgf keys                                                               %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%





%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% coordinate system / frame of reference

\tikzset{
  /tikzmechs/cos/.unknown/.code={%
    \let\currname\pgfkeyscurrentname%
    \let\currval\pgfkeyscurrentvalue%
    \ifx#1\pgfkeysnovalue%
      \tikztikzmechsset{%
        remaining keys/.append style/.expand once={\currname}%
      }%
    \else%
      \tikztikzmechsset{%
        remaining keys/.append style/.expand twice={\expandafter\currname\expandafter=\currval}%
      }%
    \fi%
  },%
  % Prefix of the frame nodes
  /tikzmechs/cos/name/.initial={cos},%
  %
  % Extension of axes in the opposite direction
  % /tikzmechs/cos/x extend
  % 
  % Axes labels
  /tikzmechs/cos/x label/.initial={$x$},
  /tikzmechs/cos/y label/.initial={$y$},
  /tikzmechs/cos/z label/.initial={$z$},
  %
  % Style for x-axis
  /tikzmechs/cos/x axis/style/.style={%
    ->,%
  },%
  /tikzmechs/cos/x axis/.code={%
    \tikzset{/tikzmechs/cos/x axis/style/.append style={#1}}%
  },%
  %
  % Style for y-axis
  /tikzmechs/cos/y axis/style/.style={%
    ->,%
  },%
  /tikzmechs/cos/y axis/.code={%
    \tikzset{/tikzmechs/cos/y axis/style/.append style={#1}}%
  },%
  %
  % Style for z-axis
  /tikzmechs/cos/z axis/style/.style={%
    ->,%
  },%
  /tikzmechs/cos/z axis/.code={%
    \tikzset{/tikzmechs/cos/z axis/style/.append style={#1}}%
  },%
  % 
  % Style for node of x-axis
  /tikzmechs/cos/x node/style/.style={%
    pos=1.0,%
    anchor=west,%
    ->,%
  },%
  /tikzmechs/cos/x node/.code={%
    \tikzset{/tikzmechs/cos/x node/style/.append style={#1}}%
  },%
  %
  % Style for node of y-axis
  /tikzmechs/cos/y node/style/.style={%
    pos=1.0,%
    anchor=south,%
    ->,%
  },%
  /tikzmechs/cos/y node/.code={%
    \tikzset{/tikzmechs/cos/y node/style/.append style={#1}}%
  },%
  %
  % Style for node of z-axis
  /tikzmechs/cos/z node/style/.style={%
    pos=1.0,%
    anchor=south,%
    ->,%
  },%
  /tikzmechs/cos/z node/.code={%
    \tikzset{/tikzmechs/cos/z node/style/.append style={#1}}%
  },%
}


%%
% @sample \coorsys{center}{x-axis}{y-axis};
% @sample \coorsys[x axis={drawnaw=red}]{center}{x-axis}{y-axis};
%%
\NewDocumentCommand{\coorsys}{ O{} m m m}{{% note the double curly braces
  % Reset the remaining keys style
  \tikztikzmechsresetstyle{remaining keys}%
  % Set the keys for this commands namespace
  \tikztikzmechsset{%
    % Change the current namespace
    cos/.cd,%
    % And set all keys
    #1,%
  }%
  \begin{scope}[%
      shift={#2},%
    ]
    % X-Axis
    \draw[%
        /tikzmechs/cos/x axis/style,%
        /tikzmechs/remaining keys,%
      ]%
        (0,0)%
        -- #3%
        node[%
            /tikzmechs/cos/x node/style,%
          ]%
          (\tikztikzmechsget{cos/name} x)%
          {\tikztikzmechsget{cos/x label}};
    % Y-Axis
    \draw[%
        /tikzmechs/cos/y axis/style,%
        /tikzmechs/remaining keys,%
      ]%
        (0,0)%
        -- #4%
        node[%
            /tikzmechs/cos/y node/style,%
          ]%
          (\tikztikzmechsget{cos/name} y)%
          {\tikztikzmechsget{cos/y label}};
  \end{scope}%
}}


%%
% @sample \coorsysxyz{center}{x-axis}{y-axis}{z-axis};
% @sample \coorsysxyz[x axis={drawnaw=red}]{center}{x-axis}{y-axis}{z-axis};
%%
\NewDocumentCommand{\coorsysxyz}{ O{} m m m m}{{% note the double curly braces
  % Reset the remaining keys style
  \tikztikzmechsresetstyle{remaining keys}%
  % Set the keys for this commands namespace
  \tikztikzmechsset{%
    % Change the current namespace
    cos/.cd,%
    % And set all keys
    #1,%
  }%
  \begin{scope}[%
      shift={#2},%
    ]
    % X-Axis
    \draw[%
        /tikzmechs/cos/x axis/style,%
        /tikzmechs/remaining keys,%
      ]%
        (0,0)%
        -- #3%
        node[%
            /tikzmechs/cos/x node/style,%
          ]%
          (\tikztikzmechsget{cos/name} x)%
          {\tikztikzmechsget{cos/x label}};
    % Y-Axis
    \draw[%
        /tikzmechs/cos/y axis/style,%
        /tikzmechs/remaining keys,%
      ]%
        (0,0)%
        -- #4%
        node[%
            /tikzmechs/cos/y node/style,%
          ]%
          (\tikztikzmechsget{cos/name} y)%
          {\tikztikzmechsget{cos/y label}};
    % Z-Axis
    \draw[%
        /tikzmechs/cos/z axis/style,%
        /tikzmechs/remaining keys,%
      ]%
        (0,0)%
        -- #4%
        node[%
            /tikzmechs/cos/z node/style,%
          ]%
          (\tikztikzmechsget{cos/name} z)%
          {\tikztikzmechsget{cos/z label}};
  \end{scope}%
}}

%% END coordinate system / frame of reference
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%





%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% rigid body

\newlength\tikz@tikzmechs@rigidbody@width
\newlength\tikz@tikzmechs@rigidbody@height

% Namespace for configuration of the "rigid body" style
\tikzset{%
  % Collect anything unknown in style '/tikzmechs/remaining keys':
  /tikzmechs/rigid body/.unknown/.code={%
    \let\currname\pgfkeyscurrentname%
    \let\currval\pgfkeyscurrentvalue%
    \ifx#1\pgfkeysnovalue%
      \tikztikzmechsset{%
        remaining keys/.append style/.expand once={\currname}%
      }%
    \else%
      \tikztikzmechsset{%
        remaining keys/.append style/.expand twice={\expandafter\currname\expandafter=\currval}%
      }%
    \fi%
  },%
  % Name of the rigid body node
  /tikzmechs/rigid body/name/.initial={rigid body},%
  % Height of the rigid body element
  /tikzmechs/rigid body/height/.code={%
    \setlength{\tikz@tikzmechs@rigidbody@height}{#1}%
  },%
  /tikzmechs/rigid body/height=1.00em,%
  % Width of the rigid body element
  /tikzmechs/rigid body/width/.code={%
    \setlength{\tikz@tikzmechs@rigidbody@width}{#1}%
  },%
  /tikzmechs/rigid body/width=2.00em,%
}


%%
% @sample \rigidbody{coord};
% @sample \rigidbody[tikz arguments]{coord};
%%
\NewDocumentCommand{\rigidbody}{ O{} m }{{% note the double curly braces
  % Reset the remaining keys style
  \tikztikzmechsresetstyle{remaining keys}%
  % Set the keys for this commands namespace
  \tikztikzmechsset{%
    % Change the current namespace
    rigid body/.cd,%
    % And set all keys
    #1,%
  }%
  % Rigid body node
  \node[%
      shape=rectangle,%
      draw=Black,%
      inner sep=0.00pt,%
      outer sep=0.00pt,%
      minimum width=\tikz@tikzmechs@rigidbody@width,%
      minimum height=\tikz@tikzmechs@rigidbody@height,%
      /tikzmechs/remaining keys,%
    ]%
    (\tikztikzmechsget{rigid body/name})%
    at #2%
    {};%
}}

%% END rigid body
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% center of mass

\newlength\tikz@tikzmechs@centerofmass@radius

% Namespace for configuration of the "center of mass" style
\tikzset{%
  % Collect anything unknown in style '/tikzmechs/remaining keys':
  /tikzmechs/center of mass/.unknown/.code={%
    \let\currname\pgfkeyscurrentname%
    \let\currval\pgfkeyscurrentvalue%
    \ifx#1\pgfkeysnovalue%
      \tikztikzmechsset{%
        remaining keys/.append style/.expand once={\currname}%
      }%
    \else%
      \tikztikzmechsset{%
        remaining keys/.append style/.expand twice={\expandafter\currname\expandafter=\currval}%
      }%
    \fi%
  },%
  %
  % Prefix of the center of mass node
  /tikzmechs/center of mass/name/.initial={center of mass},%
  %
  % Size of the center of mass element
  /tikzmechs/center of mass/radius/.code={%
    \setlength{\tikz@tikzmechs@centerofmass@radius}{#1}%
  },%
  % Set radius initially
  /tikzmechs/center of mass/radius=0.50em,%
}


%%
% @sample \centerofmass{coord};
% @sample \centerofmass[tikz arguments]{coord};
%%
\NewDocumentCommand{\centerofmass}{ O{} m }{{% note the double curly braces
  % Reset the remaining keys style
  \tikztikzmechsresetstyle{remaining keys}%
  % Set the keys for this commands namespace
  \tikztikzmechsset{%
    % Change the current namespace
    center of mass/.cd,%
    % And set all keys
    #1,%
  }%
  %
  \begin{scope}
    % Center of mass node
    \node[%
        shape=circle,%
        draw=Black,%
        fill=White,%
        inner sep=0.00pt,%
        outer sep=0.00pt,%
        minimum width=2\tikz@tikzmechs@centerofmass@radius,%
        minimum height=2\tikz@tikzmechs@centerofmass@radius,%
        /tikzmechs/remaining keys,%
      ]%
      (\tikztikzmechsget{center of mass/name})%
      at #2%
      {};%
      % upper left part
      \begin{scope}
        \clip%
          (\tikztikzmechsget{center of mass/name}.center)
          circle[radius=\tikz@tikzmechs@centerofmass@radius];
        
        \draw[%
            fill=Black,%
            /tikzmechs/remaining keys,%
            draw=none,%
          ]%
          (\tikztikzmechsget{center of mass/name}.west)
            rectangle (\tikztikzmechsget{center of mass/name}.north);
      \end{scope}
      % lower right part
      \begin{scope}
        \clip%
          (\tikztikzmechsget{center of mass/name}.center)
          circle[radius=\tikz@tikzmechs@centerofmass@radius];
        
        \draw[%
            fill=Black,%
            /tikzmechs/remaining keys,%
            draw=none,%
          ]%
          (\tikztikzmechsget{center of mass/name}.east)
            rectangle (\tikztikzmechsget{center of mass/name}.south);
      \end{scope}
      % % Filled elements
      % \draw[%
      %     draw=Black,%
      %     fill=Black,%
      %     /tikzmechs/remaining keys,%
      %   ]%
      %   (\tikztikzmechsget{center of mass/name}.center)%
      %   -- (\tikztikzmechsget{center of mass/name}.north)%
      %   arc(90:180:\tikz@tikzmechs@centerofmass@radius)%
      %   -- (\tikztikzmechsget{center of mass/name}.west)%
      %   -- (\tikztikzmechsget{center of mass/name}.center)%
      %   -- cycle;%
      % % Bottom right filled part
      % \draw[%
      %     draw=Black,%
      %     fill=Black,%
      %     /tikzmechs/remaining keys,%
      %   ]%
      %   (\tikztikzmechsget{center of mass/name}.center)%
      %   -- (\tikztikzmechsget{center of mass/name}.south)%
      %   arc(270:360:\tikz@tikzmechs@centerofmass@radius)%
      %   -- (\tikztikzmechsget{center of mass/name}.east)%
      %   -- (\tikztikzmechsget{center of mass/name}.center)%
      %   -- cycle;%
  \end{scope}
}}

%% END center of mass
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%





%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% ground

\newlength\tikz@tikzmechs@ground@width
\newlength\tikz@tikzmechs@ground@height
\newlength\tikz@tikzmechs@ground@distance
\newlength\pgf@tikzmechs@ground@diagonal
\newlength\tikz@tikzmechs@ground@diagonal

% Namespace for configuration of the "ground" style
\tikzset{%
  % Collect anything unknown in style '/tikzmechs/remaining keys':
  /tikzmechs/ground/.unknown/.code={%
    \let\currname\pgfkeyscurrentname%
    \let\currval\pgfkeyscurrentvalue%
    \ifx#1\pgfkeysnovalue%
      \tikztikzmechsset{%
        remaining keys/.append style/.expand once={\currname}%
      }%
    \else%
      \tikztikzmechsset{%
        remaining keys/.append style/.expand twice={\expandafter\currname\expandafter=\currval}%
      }%
    \fi%
  },%
  % Rotation of the ground
  /tikzmechs/ground/rotate/.initial=0,%
  % Prefix of the ground node
  /tikzmechs/ground/name/.initial={ground},%
  % Width of the ground element
  /tikzmechs/ground/width/.code={%
    \setlength{\tikz@tikzmechs@ground@width}{#1}%
  },%
  /tikzmechs/ground/width=1.00em,%
  % Height of the ground element
  /tikzmechs/ground/height/.code={%
    \setlength{\tikz@tikzmechs@ground@height}{#1}%
  },%
  /tikzmechs/ground/height=1.00em,%
  % Distance of the hatches
  /tikzmechs/ground/distance/.code={%
    \setlength{\tikz@tikzmechs@ground@distance}{#1}%
  },%
  /tikzmechs/ground/distance=0.33ex,%
  % Angle of hatching
  /tikzmechs/ground/angle/.initial=45,%
}


%%
% @sample \ground{top coord};
% @sample \ground[tikz arguments]{coord};
%%
\NewDocumentCommand{\ground}{ O{} m }{{% note the double curly braces
  % Reset the remaining keys style
  \tikztikzmechsresetstyle{remaining keys}%
  % Set the keys for this commands namespace
  \tikztikzmechsset{%
    % Change the current namespace
    ground/.cd,%
    % And set all keys
    #1,%
  }%
  \begin{scope}
    % Ground surrounding node
    \node[%
        shape=rectangle,%
        draw=none,%
        anchor=north,%
        inner sep=0pt,%
        outer sep=0pt,%
        minimum width=\tikz@tikzmechs@ground@width,%
        minimum height=\tikz@tikzmechs@ground@height,%
        /tikzmechs/remaining keys,%
      ]%
      (\tikztikzmechsget{ground/name})%
      at #2%
      {};
    %
    % Ground hatching
    \begin{scope}
      % Clipping as the ground hatching is drawn too largely
      \clip%
        (\tikztikzmechsget{ground/name}.north west)%
          rectangle (\tikztikzmechsget{ground/name}.south east);
      % Calculate end of the hatching loop
      \pgfmathtruncatemacro\tikz@tikzmechs@ground@loopend{1 + sqrt(\tikz@tikzmechs@ground@width^2 + (tan(\tikztikzmechsget{ground/angle})*\tikz@tikzmechs@ground@width)^2)/(\tikz@tikzmechs@ground@distance)}%
      % Calculate the length of the diagonal of hatching
      \pgfmathsetlengthmacro\pgf@tikzmechs@ground@diagonal{sqrt(\tikz@tikzmechs@ground@width^2 + \tikz@tikzmechs@ground@height^2)}%
      \setlength\tikz@tikzmechs@ground@diagonal{\pgf@tikzmechs@ground@diagonal}%
      % Loop for each hatching line
      \foreach \nline in {0,...,\tikz@tikzmechs@ground@loopend} {%
        \draw[%
          draw=Black,%
          /tikzmechs/remaining keys,%
        ]%
        (\tikztikzmechsget{ground/name}.south west)%
          ++(\tikztikzmechsget{ground/angle}:{(\nline+0.5)*\tikz@tikzmechs@ground@distance})%
          ++({\tikztikzmechsget{ground/angle}+90}:\tikz@tikzmechs@ground@diagonal)%
        -- ++({\tikztikzmechsget{ground/angle}-90}:2\tikz@tikzmechs@ground@diagonal);%
      }%
    \end{scope}
    % 
    % Ground surface
    \draw[%
        draw=Black,%
        /tikzmechs/remaining keys,%
      ]%
      (\tikztikzmechsget{ground/name}.north west)%
      -- (\tikztikzmechsget{ground/name}.north east);%
  \end{scope}
}}

%% END ground
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%





%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% spring

\newlength\tikz@tikzmechs@spring@length
\newlength\tikz@tikzmechs@spring@amplitude

% Namespace for configuration of the "spring" style
\tikzset{%
  % Collect anything unknown in style '/tikzmechs/remaining keys':
  /tikzmechs/spring/.unknown/.code={%
    \let\currname\pgfkeyscurrentname%
    \let\currval\pgfkeyscurrentvalue%
    \ifx#1\pgfkeysnovalue%
      \tikztikzmechsset{%
        remaining keys/.append style/.expand once={\currname}%
      }%
    \else%
      \tikztikzmechsset{%
        remaining keys/.append style/.expand twice={\expandafter\currname\expandafter=\currval}%
      }%
    \fi%
  },%
  % Length of the spring
  /tikzmechs/spring/length/.code={%
    \setlength{\tikz@tikzmechs@spring@length}{#1}%
  },%
  /tikzmechs/spring/length=1.00em,%
  % Spring element amplitude
  /tikzmechs/spring/amplitude/.code={%
    \setlength{\tikz@tikzmechs@spring@amplitude}{#1}%
  },%
  /tikzmechs/spring/amplitude=1.00ex,%
  % Number of periods in the spring between start and end
  /tikzmechs/spring/periods/.initial=5,%
  % Prefix of the spring node (center of the spring)
  /tikzmechs/spring/name/.initial={spring},%
}

% TikZ style to draw a spring
\tikzset{%
  % Draw a linear spring of configured lengths
  /tikzmechs/spring/style/.style={%
    % Actual decoration of path will be a "zig zag" line to resemble the spring
    decoration={%
      zigzag,%
      pre length=0.50*(\pgfmetadecoratedpathlength-\tikz@tikzmechs@spring@length),%
      post length=0.50*(\pgfmetadecoratedpathlength-\tikz@tikzmechs@spring@length),%
      segment length=(\tikz@tikzmechs@spring@length/\tikztikzmechsget{spring/periods}),%
      amplitude=\tikz@tikzmechs@spring@amplitude,%
    },%
    % Perform the decoration
    decorate,%
    %
    postaction={%
      decoration={%
        markings,%
        mark=at position 0.50 with {%
          % Spring node
          \node[%
              shape=rectangle,%
              draw=none,%
              inner sep=0.00pt,%
              outer sep=0.00pt,%
              align=center,%
              minimum height=2.00\pgflinewidth + 2.00\tikz@tikzmechs@spring@amplitude,%
              minimum width=2.00\pgflinewidth + 1.00\tikz@tikzmechs@spring@length,%
              /tikzmechs/remaining keys,%
            ]%
            (\tikztikzmechsget{spring/name})%
            {};%
        },%
      },%
      decorate,%
    },
  },%
}%

% @sample \spring{start}{end};
% @sample \spring[tikz arguments]{start}{end};
%%
\NewDocumentCommand{\spring}{ O{} m m }{{% note the double curly braces
  % Reset the remaining keys style
  \tikztikzmechsresetstyle{remaining keys}%
  % Set the keys for this commands namespace
  \tikztikzmechsset{%
    % Change the current namespace
    spring/.cd,%
    % And set all keys
    #1,%
  }%
  \draw[%
      /tikzmechs/spring/style,%
      /tikzmechs/remaining keys,%
    ]%
    #2%
    -- #3;%
}}

%% END spring
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%





%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% damper

\newlength\tikz@tikzmechs@damper@length
\newlength\tikz@tikzmechs@damper@width
\newlength\tikz@tikzmechs@damper@dashpotwidth

% Namespace for configuration of the "damper" style
\tikzset{%
  % Collect anything unknown in style '/tikzmechs/remaining keys':
  /tikzmechs/damper/.unknown/.code={%
    \let\currname\pgfkeyscurrentname%
    \let\currval\pgfkeyscurrentvalue%
    \ifx#1\pgfkeysnovalue%
      \tikztikzmechsset{%
        remaining keys/.append style/.expand once={\currname}%
      }%
    \else%
      \tikztikzmechsset{%
        remaining keys/.append style/.expand twice={\expandafter\currname\expandafter=\currval}%
      }%
    \fi%
  },%
  % Length of the damper
  /tikzmechs/damper/length/.code={%
    \setlength{\tikz@tikzmechs@damper@length}{#1}%
  },%
  /tikzmechs/damper/length=1.00ex,%
  % damper element amplitude
  /tikzmechs/damper/width/.code={%
    \setlength{\tikz@tikzmechs@damper@width}{#1}%
  },%
  /tikzmechs/damper/width=1.00em,%
  % Damper spacing between dashpot and cylinder
  /tikzmechs/damper/dashpot width/.code={%
    \setlength{\tikz@tikzmechs@damper@dashpotwidth}{#1}%
  },%
  /tikzmechs/damper/dashpot width=0.90em,%
  % Prefix of the damper node (center of the damper)
  /tikzmechs/damper/name/.initial={damper},%
  % Stroke of the damper wrt the cylinder
  /tikzmechs/damper/stroke/.initial=0.5,%
}

% TikZ style to draw a damper
\tikzset{%
  % Draw a damper of configured lengths
  /tikzmechs/damper/style/.style={%
    % Actual decoration of path will be a node with only parts drawn
    decoration={%
      markings,%
      mark connection node=\tikztikzmechsget{damper/name},%
      mark=at position 0.50 with {%
        % Damper node
        \node[%
            shape=rectangle,%
            draw=none,%
            inner sep=0.00pt,%
            outer sep=0.00pt,%
            minimum width=1\tikz@tikzmechs@damper@length,%
            minimum height=2\tikz@tikzmechs@damper@width,%
          ]%
            (\tikztikzmechsget{damper/name})%
            {};
        % Cylinder
        \draw[%
            /tikzmechs/remaining keys,%
          ]%
          (\tikztikzmechsget{damper/name}.north west)%
          -- (\tikztikzmechsget{damper/name}.north east)%
          -- (\tikztikzmechsget{damper/name}.south east)%
          -- (\tikztikzmechsget{damper/name}.south west);
        % Lever
        \draw[%
            /tikzmechs/remaining keys,%
          ]%
          (\tikztikzmechsget{damper/name}.west)%
          -- ($(\tikztikzmechsget{damper/name}.west)!\tikztikzmechsget{damper/stroke}!(\tikztikzmechsget{damper/name}.east)$)%
            node[%
                pos=0.00,%
                coordinate,%
              ]%
              (\tikztikzmechsget{damper/name} stroke start)%
              {}
            node[%
                pos=1.00,%
                coordinate,%
              ]%
              (\tikztikzmechsget{damper/name} stroke end)%
              {};
        % Dashpot
        \draw[%
            /tikzmechs/remaining keys,%
          ]%
          (\tikztikzmechsget{damper/name} stroke end)%
            ++(0, 1.00\tikz@tikzmechs@damper@dashpotwidth)%
          -- ++(0, -2.00\tikz@tikzmechs@damper@dashpotwidth);
      }%
    },%
    % Perform decoration
    decorate,%
  },%
}%


%%
% @sample \damper{start}{end};
% @sample \damper[tikz arguments]{start}{end};
%%
\NewDocumentCommand{\damper}{ O{} m m }{{% note the double curly braces
  % Reset the remaining keys style
  \tikztikzmechsresetstyle{remaining keys}%
  % Set the keys for this commands namespace
  \tikztikzmechsset{%
    % Change the current namespace
    damper/.cd,%
    % And set all keys
    #1,%
  }%
  % And draw the object
  \draw[%
      /tikzmechs/damper/style,%
      /tikzmechs/remaining keys,%
    ]%
    #2%
    -- #3;%
}}

%% END damper
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% spring damper element

\newlength\tikz@tikzmechs@sde@radius
\newif\iftikz@tikzmechs@sde@rotational
\tikz@tikzmechs@sde@rotationalfalse

\tikzset{%
  % Collect anything unknown in style '/tikzmechs/remaining keys':
  /tikzmechs/sde/.unknown/.code={%
    \let\currname\pgfkeyscurrentname%
    \let\currval\pgfkeyscurrentvalue%
    \ifx#1\pgfkeysnovalue%
      \tikztikzmechsset{%
        remaining keys/.append style/.expand once={\currname}%
      }%
    \else%
      \tikztikzmechsset{%
        remaining keys/.append style/.expand twice={\expandafter\currname\expandafter=\currval}%
      }%
    \fi%
  },%
  % Name of the node
  /tikzmechs/sde/name/.initial={sde \iftikz@tikzmechs@sde@rotational rot\else lin\fi},%
  % Radius/edge length of the SDE node
  /tikzmechs/sde/radius/.code={%
    \setlength{\tikz@tikzmechs@sde@radius}{#1}%
  },%
  /tikzmechs/sde/radius=0.50ex,%
  % Type of the sde: linear/rotational
  /tikzmechs/sde/type/.is choice,%
  /tikzmechs/sde/type/linear/.code={%
    \tikz@tikzmechs@sde@rotationalfalse%
  },%
  /tikzmechs/sde/type/rotational/.code={%
    \tikz@tikzmechs@sde@rotationaltrue%
  },%
}


%%
% @sample \sde{coord};
% @sample \sde[tikz arguments]{coord};
%%
\NewDocumentCommand{\sde}{ O{} m }{{% note the double curly braces
  % Reset the remaining keys style
  \tikztikzmechsresetstyle{remaining keys}%
  % Set the keys for this commands namespace
  \tikztikzmechsset{%
    % Change the current namespace
    sde/.cd,%
    % And set all keys
    #1,%
  }%
  \begin{scope}
    \iftikz@tikzmechs@sde@rotational
      % SDE node
      \node[%
          shape=circle,%
          draw=Black,%
          minimum size=2\tikz@tikzmechs@sde@radius,%
          text width=2\tikz@tikzmechs@sde@radius,%
          minimum width=2\tikz@tikzmechs@sde@radius,%
          minimum height=2\tikz@tikzmechs@sde@radius,%
          align=center,%
          inner sep=0.00pt,%
          outer sep=0.00pt,%
          /tikzmechs/remaining keys,%
        ]%
        (\tikztikzmechsget{sde/name})%
        at #2%
        {};
    \else
      % SDE node
      \node[%
          shape=rectangle,%
          draw=Black,%
          minimum size=2\tikz@tikzmechs@sde@radius,%
          text width=2\tikz@tikzmechs@sde@radius,%
          minimum width=2\tikz@tikzmechs@sde@radius,%
          minimum height=2\tikz@tikzmechs@sde@radius,%
          align=center,%
          inner sep=0.00pt,%
          outer sep=0.00pt,%
          /tikzmechs/remaining keys,%
        ]%
        (\tikztikzmechsget{sde/name})%
        at #2%
        {};
    \fi
    %
    \draw[%
        draw=Black,%
        /tikzmechs/remaining keys,%
      ]%
      (\tikztikzmechsget{sde/name}.north west)%
      -- (\tikztikzmechsget{sde/name}.south east);%
    %
    \draw[%
        draw=Black,%
        /tikzmechs/remaining keys,%
      ]%
      (\tikztikzmechsget{sde/name}.south west)%
      -- (\tikztikzmechsget{sde/name}.north east);%
  \end{scope}
}}


%%
% @sample \sdelin{coord};
% @sample \sdelin[tikz arguments]{coord};
%%
\NewDocumentCommand{\sdelin}{ O{} m }{{% note the double curly braces
  \sde[#1, type=linear]{#2}
}}


%%
% @sample \sderot{coord};
% @sample \sderot[tikz arguments]{coord};
%%
\NewDocumentCommand{\sderot}{ O{} m }{{% note the double curly braces
  \sde[#1, type=rotational]{#2}
}}

%% END spring damper element
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%





%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% bearing

\newlength\tikz@tikzmechs@bearing@ground@width
\newlength\tikz@tikzmechs@bearing@ground@height
\newlength\tikz@tikzmechs@bearing@bearing@width
\newlength\tikz@tikzmechs@bearing@bearing@height
\newlength\tikz@tikzmechs@bearing@gap@height
\newif\iftikz@tikzmechs@bearing@floating
\tikz@tikzmechs@bearing@floatingfalse

\tikzset{%
  % Collect anything unknown in style '/tikzmechs/remaining keys':
  /tikzmechs/bearing/.unknown/.code={%
    \let\currname\pgfkeyscurrentname%
    \let\currval\pgfkeyscurrentvalue%
    \ifx#1\pgfkeysnovalue%
      \tikztikzmechsset{%
        remaining keys/.append style/.expand once={\currname}%
      }%
    \else%
      \tikztikzmechsset{%
        remaining keys/.append style/.expand twice={\expandafter\currname\expandafter=\currval}%
      }%
    \fi%
  },%
  % Name of the node
  /tikzmechs/bearing/name/.initial={bearing},%
  /tikzmechs/bearing/name/.initial={bearing \iftikz@tikzmechs@bearing@floating floating\else fixed\fi},%
  % % Type of the bearing: fixed/floating
  /tikzmechs/bearing/type/.is choice,%
  /tikzmechs/bearing/type/fixed/.code={%
    \tikz@tikzmechs@bearing@floatingfalse%
  },%
  /tikzmechs/bearing/type/floating/.code={%
    \tikz@tikzmechs@bearing@floatingtrue%
  },%
  % Width of the bearing: forward to other keys
  /tikzmechs/bearing/width/.code={%
    \tikztikzmechsset{bearing/bearing width=0.5#1}%
    \tikztikzmechsset{bearing/ground width=#1}%
  },%
  % Width of the bearing
  /tikzmechs/bearing/height/.code={%
    \tikztikzmechsset{bearing/bearing height=0.5#1}%
    \tikztikzmechsset{bearing/ground height=0.5#1}%
  },%
  % Shortcut to the style for the support element
  /tikzmechs/bearing/bearing/.code={%
    \tikztikzmechsset{bearing/bearing/style/.append style={#1}}%
  },%
  % Default style for the support element
  /tikzmechs/bearing/bearing/style/.style={%
    draw=Black,%
  },%
  % Width of the support
  /tikzmechs/bearing/bearing width/.code={%
    \setlength{\tikz@tikzmechs@bearing@bearing@width}{#1}%
  },%
  /tikzmechs/bearing/bearing width=0.75em,%
  % Height of the support
  /tikzmechs/bearing/bearing height/.code={%
    \setlength{\tikz@tikzmechs@bearing@bearing@height}{#1}%
  },%
  /tikzmechs/bearing/bearing height=1.00em,%
  % Shortcut to the style for the support element
  /tikzmechs/bearing/ground/.code={%
    \tikztikzmechsset{bearing/ground/style/.append style={#1}}%
  },%
  %
  % Default style for the ground element
  /tikzmechs/bearing/ground/style/.style={%
    width=\tikz@tikzmechs@bearing@ground@width,%
    height=\tikz@tikzmechs@bearing@ground@height,%
    name=\tikztikzmechsget{bearing/name} ground,%
  },%
  % Width of the ground
  /tikzmechs/bearing/ground width/.code={%
    \tikztikzmechsset{bearing/ground={width=#1}}%
    \setlength{\tikz@tikzmechs@bearing@ground@width}{#1}%
  },%
  /tikzmechs/bearing/ground width=1.50em,%
  % Height of the ground
  /tikzmechs/bearing/ground height/.code={%
    \tikztikzmechsset{bearing/ground={height=#1}}%
    \setlength{\tikz@tikzmechs@bearing@ground@height}{#1}%
  },%
  /tikzmechs/bearing/ground height=1.00em,%
  % Gap of the floating bearing
  /tikzmechs/bearing/gap/.code={%
    \setlength{\tikz@tikzmechs@bearing@gap@height}{#1}%
  },%
  %
  %
  /tikzmechs/bearing/gap=0.25ex,%
}


%%
% @sample \bearing{coord};
% @sample \bearing[tikz options]{coord};
%%
\NewDocumentCommand{\bearing}{ O{} m }{{% note the double curly braces
  % Reset the remaining keys style
  \tikztikzmechsresetstyle{remaining keys}%
  % Set the keys for this commands namespace
  \tikztikzmechsset{%
    % Change the current namespace
    bearing/.cd,%
    % And set all keys
    #1,%
  }%
  %
  \begin{scope}
    % The ground
    \ground[%
        /tikzmechs/bearing/ground/style,%
        /tikzmechs/remaining keys,%
      ]%
      {($#2-(0,\tikz@tikzmechs@bearing@bearing@height)$)}%
    %
    \iftikz@tikzmechs@bearing@floating
      % Floating bearing
      % The bearing itself
      \draw[%
          /tikzmechs/bearing/bearing/style,%
          /tikzmechs/remaining keys,%
        ]%
        (\tikztikzmechsget{bearing/name} ground.north)%
          ++ (0, \tikz@tikzmechs@bearing@gap@height)%
        -- ++(0.5\tikz@tikzmechs@bearing@bearing@width, 0)%
        -- ++(-0.5\tikz@tikzmechs@bearing@bearing@width, \tikz@tikzmechs@bearing@bearing@height)%
        -- ++(-0.5\tikz@tikzmechs@bearing@bearing@width, -\tikz@tikzmechs@bearing@bearing@height)%
        -- ++(\tikz@tikzmechs@bearing@bearing@width,0)%
        -- cycle;%
      %
      % The bearing's floating ground
      \draw[
          /tikzmechs/bearing/bearing/style,%
          /tikzmechs/remaining keys,%
        ]%
        (\tikztikzmechsget{bearing/name} ground.north)%
          ++ (0, \tikz@tikzmechs@bearing@gap@height)%
        ++ (-0.5\tikz@tikzmechs@bearing@ground@width, 0)%
        -- ++(\tikz@tikzmechs@bearing@ground@width, 0);%
    \else
      %
      % Fixed bearing
      % The bearing itself
      \draw[%
          /tikzmechs/bearing/bearing/style,%
          /tikzmechs/remaining keys,%
        ]%
        (\tikztikzmechsget{bearing/name} ground.north)%
        -- ++(0.5\tikz@tikzmechs@bearing@bearing@width, 0)%
        -- ++(-0.5\tikz@tikzmechs@bearing@bearing@width, \tikz@tikzmechs@bearing@bearing@height)%
        -- ++(-0.5\tikz@tikzmechs@bearing@bearing@width, -\tikz@tikzmechs@bearing@bearing@height)%
        -- ++(\tikz@tikzmechs@bearing@bearing@width,0)%
        -- cycle;
    \fi
  \end{scope}
}}


%%
% @sample \bearingfixed{coord};
% @sample \bearingfixed[tikz arguments]{coord};
%%
\NewDocumentCommand{\bearingfixed}{ O{} m }{{% note the double curly braces
  \bearing[#1, type=fixed]{#2};
}}


%%
% @sample \bearingfloating{coord};
% @sample \bearingfloating[tikz arguments]{coord};
%%
\NewDocumentCommand{\bearingfloating}{ O{} m }{{% note the double curly braces
  \bearing[#1, type=floating]{#2};
}}

%% END bearing
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%





%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% hinge

\newlength\tikz@tikzmechs@hinge@radius

\tikzset{%
  % Collect anything unknown in style '/tikzmechs/remaining keys':
  /tikzmechs/hinge/.unknown/.code={%
    \let\currname\pgfkeyscurrentname%
    \let\currval\pgfkeyscurrentvalue%
    \ifx#1\pgfkeysnovalue%
      \tikztikzmechsset{%
        remaining keys/.append style/.expand once={\currname}%
      }%
    \else%
      \tikztikzmechsset{%
        remaining keys/.append style/.expand twice={\expandafter\currname\expandafter=\currval}%
      }%
    \fi%
  },%
  % Name of the node
  /tikzmechs/hinge/name/.initial={hinge},%
  % Radius of the hinge
  /tikzmechs/hinge/radius/.code={%
    \setlength{\tikz@tikzmechs@hinge@radius}{#1}%
  },%
  /tikzmechs/hinge/radius=1.15em,%
  % Angle of revolution
  /tikzmechs/hinge/angle/.initial=0,%
}


%%
% @sample \hinge{coord};
% @sample \hinge[tikz arguments]{coord};
%%
\NewDocumentCommand{\hinge}{ O{} m }{{% note the double curly braces
  % Reset the remaining keys style
  \tikztikzmechsresetstyle{remaining keys}%
  % Set the keys for this commands namespace
  \tikztikzmechsset{%
    % Change the current namespace
    hinge/.cd,%
    % And set all keys
    #1,%
  }%
  %
  \begin{scope}
    % Hinge node
    \node[%
        shape=circle,%
        draw=Black,%
        minimum width=2\tikz@tikzmechs@hinge@radius,%
        minimum height=2\tikz@tikzmechs@hinge@radius,%
        inner sep=0.00pt,%
        outer sep=0.00pt,%
        /tikzmechs/remaining keys,%
      ]%
      (\tikztikzmechsget{hinge/name})%
      at #2%
      {};
    % 
    % Hinge
    \draw[%
        draw=Black,%
        /tikzmechs/remaining keys,%
      ]%
      (\tikztikzmechsget{hinge/name}.center)%
        ++(\tikztikzmechsget{hinge/angle}:0.75\tikz@tikzmechs@hinge@radius)%
        arc(\tikztikzmechsget{hinge/angle}:{180+\tikztikzmechsget{hinge/angle}}:0.75\tikz@tikzmechs@hinge@radius);
  \end{scope}
}}

%% END hinge
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%% END drawing commands                                                       %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Process options passed to this TikZ/PGF packages
% \ProcessPgfPackageOptions{/tikzmechs}

\makeatother

% Done
\endinput

%%
%% End of file `tikzlibrarytikzmechs.code.tex`.
